require 'test/unit'
require 'fake_ftp'
require 'iop/file'
require 'iop/net/ftp'

class NetFtpTest < Test::Unit::TestCase

  include IOP

  Server = FakeFtp::Server.new(10000, 10001)
  Server.start

  def _test_write
    (FileReader.new(__FILE__) | FTPFileWriter.new('127.0.0.1', 10000)).process!
  end

  def _test_put
    ftp = Net::FTP.new
    ftp.connect('127.0.0.1', 10000)
    ftp.login('user', 'password')
    ftp.passive = false
    ftp.put(__FILE__)
    ftp.close
  end

  def _test_get
    ftp = Net::FTP.new
    ftp.connect('127.0.0.1', 10000)
    ftp.login('user', 'password')
    ftp.passive = true
    ftp.get('out')
    ftp.close
  end

  def test_read_file
    (FTPFileReader.new('ftp.gnu.org', '/pub/README', size: 1024, offset: 1024)).process!
  end

end